
// The interface the modem is connected to:
#define BACKEND_INTERFACE "eth1"

// The prefix for the names of the tap interfaces we are going to create,
// with numbers starting from 0 appended:
#define FRONTEND_INTERFACE_PREFIX "dsl"

// The MAC address for the first tap interface - the other interfaces will
// get MAC addresses counted up from this one:
#define FRONTEND_INTERFACE_BASE_MAC 0x0000CB221572

// Number of tap interfaces we are going to create:
#define FRONTEND_INTERFACE_COUNT 5

// This is the amount of time that we do dequeue packets "into the future".
// That is, whenever we are scheduled by the kernel, we dequeue so many packets
// that the modem is busy for this much time into the future at least, before
// we yield again (can be more if the last packet we dequeue is larger than
// needed to reach limit), so that the modem doesn't run out of data to
// transmit if we are re-scheduled a bit late. So, this basically should be
// the amount by which the actual re-scheduling moment varies:
#define SCHEDULING_JITTER (event_timer_hz*5/1000)

// This specifies how many packets the upstream queue can hold at most, no
// matter what their size is. That many data structures are allocated at
// startup, but if fewer are actually being used, only the same few will be
// used, and the unused ones may be swapped out by the kernel, so specifying
// a somewhat larger number than necessary doesn't hurt.
#define UPSTREAM_QUEUE_MAX_PACKETS 100

// This is the initial shaper bandwidth in the upstream in bits per second, and
// also is used by the profile switching code for determining the reduced rates,
// unless you change that. Please note that this usually is higher than the
// nominal line speed you are buying to account for some of the overhead.
// It should specify how much bandwidth is available for ATM cells to be
// transmitted:
#define UPSTREAM_BANDWIDTH 224000

// This is the maximum value the upstream_classify() function will ever
// return (make sure you get this right, bad things will happen otherwise :-):
#define UPSTREAM_MAX_PRIORITY 4

// This is the same as above, just for the downstream:
#define DOWNSTREAM_QUEUE_MAX_PACKETS 100
#define DOWNSTREAM_BANDWIDTH 2300000
#define DOWNSTRAM_MAX_PRIORITITY 2

// This one you probably want to simply leave alone, unless you understand
// what it does:
//#define USEMARK

