
/*
 *    miracleshaper - Traffic shaper and prioritizer for DSLs.
 *    Copyright (C) 2007  Florian Zumbiehl <florz@florz.de>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

#ifndef LIST_H
#define LIST_H

#include <stdbool.h>

struct list {
	struct list *prev,*next;
	char data[0] __attribute__ ((aligned));
};

void list_init(struct list *);

static inline void list_enqueue(struct list *list,struct list *item){
	item->prev=list->prev;
	item->next=list;
	list->prev->next=item;
	list->prev=item;
}

static inline struct list *list_dequeue(struct list *list){
	struct list *item;

	item=list->next;
	list->next=item->next;
	list->next->prev=list;
	return item;
}

static inline void list_prepend(struct list *list,struct list *item){
	list_enqueue(list->next,item);
}

static inline struct list *list_fetchlast(struct list *list){
	return list_dequeue(list->prev->prev);
}

static inline bool list_empty(const struct list *list){
	return list==list->next;
}

static inline void *listitem_get_data_p(struct list *item){
	return item->data;
}

#endif

