
/*
 *    miracleshaper - Traffic shaper and prioritizer for DSLs.
 *    Copyright (C) 2007  Florian Zumbiehl <florz@florz.de>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

#ifndef UTILS_H
#define UTILS_H

#include <stdbool.h>
#include <stdint.h>

void die(bool,const char *,...) __attribute__ ((noreturn,format (printf,2,3)));

static inline long long mac_from_6oct(const uint8_t *buf){
	long long r=0;

	for(int x=0;x<6;x++)r=(r<<8)|buf[x];
	return r;
}

static void mac_to_6oct(uint8_t *buf,long long mac){
	for(int x=6;x--;){
		buf[x]=mac&0xff;
		mac>>=8;
	}
}

#endif

